package com.laihua.projecthelper

import java.io.File
import java.io.FileReader
import java.util.ArrayList

/**
 * Author: pengjunjing
 * Date: 2022/3/4
 * Description:解析
 */
class ParseUtil {

    //引用的代码,xml引用,java kt代码引用,布局文件
    private val refCode =
        listOf<String>("@drawable", "@mipmap", "R.drawable", "R.mipmap", "R.raw", "R.layout", "@layout", "@color","R.anim","@anim")

    /**
     * 返回引用了图片资源的该行文本内容
     */
    fun parseFile(file: File): MutableList<String> {
        val reader = FileReader(file)
        val readLines = reader.readLines()
        val result = mutableListOf<String>()
        for (readLine in readLines) {
            //判断该行是否引用了图片资源
            for (s in refCode) {
                if (readLine.contains(s)) {
                    result.add(readLine)
                }
            }
        }
        return result

    }

    /**
     * 开始解析未使用的资源文件
     */
    fun startParseUnused(readImageRes: List<File>, readCodeFile: List<File>): MutableSet<File> {
        val fileNames = Array<String>(readImageRes.size) {
            //文件名 ,带后缀,去除后缀
            val name = readImageRes[it].name
            if (name.contains(".")) {
                name.substring(0, name.indexOf("."))
            } else {
                name
            }
        }

        val use = mutableListOf<String>()
        val useSet = mutableSetOf<File>()



        readCodeFile.forEach { file ->
            val parseFileLines = parseFile(file)
            if (parseFileLines.isNotEmpty()) {
                //有包含资源的代码行
                outFor@ for (i in fileNames.indices) {
                    inFor@ for (parseFileLine: String in parseFileLines) {
                        if (parseFileLine.contains(fileNames[i])) {
                            //有在使用该资源
                            use.add(fileNames[i])
                            useSet.add(readImageRes[i])
                            continue@inFor
                        }
                    }
                }

            }
        }

        val unusedSet = mutableSetOf<File>()
        unusedSet.addAll(readImageRes)
        unusedSet.removeAll(useSet)
        return unusedSet

    }
}